SystemOrganization addCategory: #ConfigurationOfSeamless!

Object subclass: #ConfigurationOfSeamless
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSeamless'!

!ConfigurationOfSeamless class methodsFor: 'development support' stamp: 'NickPapoulias 9/10/2012 13:56'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSeamless class methodsFor: 'private' stamp: 'NickPapoulias 9/10/2012 13:56'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSeamless class methodsFor: 'private' stamp: 'NickPapoulias 9/10/2012 13:56'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSeamless class methodsFor: 'private' stamp: 'NickPapoulias 9/10/2012 13:56'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSeamless class methodsFor: 'metacello tool support' stamp: 'NickPapoulias 9/10/2012 13:56'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSeamless class methodsFor: 'loading' stamp: 'NickPapoulias 9/10/2012 13:56'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSeamless class methodsFor: 'loading' stamp: 'NickPapoulias 9/10/2012 13:56'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSeamless class methodsFor: 'loading' stamp: 'NickPapoulias 9/10/2012 13:56'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSeamless class methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2012 13:56'!
project

	^self new project! !

!ConfigurationOfSeamless class methodsFor: 'development support' stamp: 'NickPapoulias 9/10/2012 13:56'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulias 9/19/2012 11:18'!
baseline01: spec

	<version: '0.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Seamless'.
		spec project: 'Fuel' with: [
			spec className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://ss3.gemstone.com/ss/Fuel'.
		].
		spec package: 'Seamless' with: [spec requires: 'Fuel']
	 ]
! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulias 5/23/2013 21:48'!
baseline02: spec

	<version: '0.2-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Seamless'.
		spec package: 'Seamless'.
	 ]
! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulais 9/30/2013 19:42'!
baseline03: spec

	<version: '0.3-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Seamless'.
		spec project: 'Fuel' with: [
			spec className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://smalltalkhub.com/mc/Pharo/Fuel/main'.
		].
		spec package: 'Seamless'  with: [spec requires: 'Fuel'].
	 ]! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulias 8/22/2014 11:10'!
baseline04: spec

	<version: '0.4-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Seamless'.
		spec project: 'Fuel' with: [
			spec className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://smalltalkhub.com/mc/Pharo/Fuel/main'.
		].
		spec package: 'Seamless'  with: [spec requires: 'Fuel'].
	 ]! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulias 9/19/2012 12:00'!
hack

	Gofer it 
		squeaksource: 'FuelExperiments';
		version: 'Fuel-MarianoMartinezPeck.726';
		load.! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2012 13:56'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulias 9/19/2012 11:20'!
version01: spec

	<version: '0.1' imports: #('0.1-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.258'.
	 ]
! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2013 22:28'!
version02: spec

	<version: '0.2' imports: #('0.2-baseline')>
	
	spec for: #common do: [
		spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.3'.
		spec package: 'Seamless' with: 'Seamless-CamilloBruni.275'.
	 ]
! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulias 11/26/2013 19:28'!
version03: spec

	"version 0.3 will iterative integrate changes from Mercury and fixes provide by projects such as CI"

	<version: '0.3' imports: #('0.3-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #stable.
		spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.3'.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.272'.
	 ]
! !

!ConfigurationOfSeamless methodsFor: 'accessing' stamp: 'NickPapoulias 11/18/2014 17:20'!
version04: spec

	"cleaning up / documenting"

	<version: '0.4' imports: #('0.4-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #stable.
		"spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.3'."
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.349'.
	 ]
! !
